$glp-col-1: (100% / 14);
$glp-col-2: ($glp-col-1 * 2);
$glp-col-3: ($glp-col-1 * 3);
$glp-col-4: ($glp-col-1 * 4);
$glp-col-5: ($glp-col-1 * 5);
$glp-col-6: ($glp-col-1 * 6);
$glp-col-7: ($glp-col-1 * 7);
$glp-col-8: ($glp-col-1 * 8);
$glp-col-9: ($glp-col-1 * 9);
$glp-col-10: ($glp-col-1 * 10);
$glp-col-11: ($glp-col-1 * 11);
$glp-col-12: ($glp-col-1 * 12);
$glp-col-13: ($glp-col-1 * 13);
$glp-col-14: 100%;

$glp-col-3-14: (100% / 3);
$glp-col-4-14: (100% / 4);
$glp-col-5-14: (100% / 5);
$glp-col-6-14: (100% / 6);
$glp-col-7-14: (100% / 7);
$glp-col-8-14: (100% / 8);
$glp-col-9-14: (100% / 9);
$glp-col-10-14: (100% / 10);
$glp-col-11-14: (100% / 11);
$glp-col-12-14: (100% / 12);
$glp-col-13-14: (100% / 13);
$glp-col-third: (100% / 3);
$glp-col-quarter: (100% / 4);
$glp-col-fifth: (100% / 5);
$glp-col-sixth: (100% / 6);
$glp-col-seventh: (100% / 7);
$glp-col-eighth: (100% / 8);
$glp-col-ninth: (100% / 9);
$glp-col-tenth: (100% / 10);
$glp-col-eleventh: (100% / 11);
$glp-col-twelth: (100% / 12);
$glp-col-thirteenth: (100% / 13);

$glp-col-4-of-14: ((100% / 14) * 4);
$glp-col-5-of-14: ((100% / 14) * 5);
$glp-col-6-of-14: ((100% / 14) * 6);
$glp-col-7-of-14: ((100% / 14) * 7);
$glp-col-8-of-14: ((100% / 14) * 8);
$glp-col-9-of-14: ((100% / 14) * 9);
$glp-col-10-of-14: ((100% / 14) * 10);
$glp-col-11-of-14: ((100% / 14) * 11);
$glp-col-12-of-14: ((100% / 14) * 12);
$glp-col-13-of-14: ((100% / 14) * 13);

// Function to generate the grid by number
@mixin make-grid-by-number($grid) {
  .#{$grid}-1 > .#{$gl-col-name},
  .#{$grid}-1 > .#{$gl-col-name} {
    flex-basis: $glp-col-14;
    max-width: $glp-col-14;
  }

  .#{$grid}-2 > .#{$gl-col-name},
  .#{$grid}-2 > .#{$gl-col-name} {
    flex-basis: $glp-col-7;
    max-width: $glp-col-7;
  }

  .#{$grid}-3 > .#{$gl-col-name},
  .#{$grid}-3 > .#{$gl-col-name} {
    flex-basis: $glp-col-3-14;
    max-width: $glp-col-3-14;
  }

  .#{$grid}-4 > .#{$gl-col-name},
  .#{$grid}-4 > .#{$gl-col-name} {
    flex-basis: $glp-col-4-14;
    max-width: $glp-col-4-14;
  }

  .#{$grid}-5 > .#{$gl-col-name},
  .#{$grid}-5 > .#{$gl-col-name} {
    flex-basis: $glp-col-5-14;
    max-width: $glp-col-5-14;
  }

  .#{$grid}-6 > .#{$gl-col-name},
  .#{$grid}-6 > .#{$gl-col-name} {
    flex-basis: $glp-col-6-14;
    max-width: $glp-col-6-14;
  }

  .#{$grid}-7 > .#{$gl-col-name},
  .#{$grid}-7 > .#{$gl-col-name} {
    flex-basis: $glp-col-2;
    max-width: $glp-col-2;
  }

  .#{$grid}-8 > .#{$gl-col-name},
  .#{$grid}-8 > .#{$gl-col-name} {
    flex-basis: $glp-col-8-14;
    max-width: $glp-col-8-14;
  }

  .#{$grid}-9 > .#{$gl-col-name},
  .#{$grid}-9 > .#{$gl-col-name} {
    flex-basis: $glp-col-9-14;
    max-width: $glp-col-9-14;
  }

  .#{$grid}-10 > .#{$gl-col-name},
  .#{$grid}-10 > .#{$gl-col-name} {
    flex-basis: $glp-col-10-14;
    max-width: $glp-col-10-14;
  }

  .#{$grid}-11 > .#{$gl-col-name},
  .#{$grid}-11 > .#{$gl-col-name} {
    flex-basis: $glp-col-11-14;
    max-width: $glp-col-11-14;
  }

  .#{$grid}-12 > .#{$gl-col-name},
  .#{$grid}-12 > .#{$gl-col-name} {
    flex-basis: $glp-col-12-14;
    max-width: $glp-col-12-14;
  }

  .#{$grid}-13 > .#{$gl-col-name},
  .#{$grid}-13 > .#{$gl-col-name} {
    flex-basis: $glp-col-13-14;
    max-width: $glp-col-13-14;
  }

  .#{$grid}-14 > .#{$gl-col-name},
  .#{$grid}-14 > .#{$gl-col-name} {
    flex-basis: $glp-col-1;
    max-width: $glp-col-1;
  }

  .with-view-all .view-all-path-wrapper {
    padding: 0 ($gl-gutter / 2) $gl-col-bottom;
    max-width: $glp-col-12-of-14;
    flex-basis: $glp-col-12-of-14;
  }
}

// Function to generate the grid by columns
@mixin make-col($col) {
  .#{$gl-grid-name} {
    > .#{$col}-1 {
      flex-basis: $glp-col-1;
      max-width: $glp-col-1;
    }

    > .#{$col}-2 {
      flex-basis: $glp-col-2;
      max-width: $glp-col-2;
    }

    > .#{$col}-3 {
      flex-basis: $glp-col-3;
      max-width: $glp-col-3;
    }

    > .#{$col}-4 {
      flex-basis: $glp-col-4;
      max-width: $glp-col-4;
    }

    > .#{$col}-5,
    .view-display-id-subprojects .col-4-of-14,
    .view-display-id-sub-working-groups .col-4-of-14  {
      flex-basis: $glp-col-5;
      max-width: $glp-col-5;
    }

    > .#{$col}-6 {
      flex-basis: $glp-col-6;
      max-width: $glp-col-6;
    }

    > .#{$col}-7 {
      flex-basis: $glp-col-7;
      max-width: $glp-col-7;
    }

    > .#{$col}-8 {
      flex-basis: $glp-col-8;
      max-width: $glp-col-8;
    }

    > .#{$col}-9,
    .view-display-id-subprojects .col-10-of-14,
    .view-display-id-sub-working-groups .col-10-of-14 {
      flex-basis: $glp-col-9;
      max-width: $glp-col-9;
    }

    > .#{$col}-10 {
      flex-basis: $glp-col-10;
      max-width: $glp-col-10;
    }

    > .#{$col}-11 {
      flex-basis: $glp-col-11;
      max-width: $glp-col-11;
    }

    > .#{$col}-12,
    .view-events .view-header .view-events {
      flex-basis: $glp-col-12;
      max-width: $glp-col-12;
    }

    > .#{$col}-13 {
      flex-basis: $glp-col-13;
      max-width: $glp-col-13;
    }

    > .#{$col}-14 {
      flex-basis: $glp-col-14;
      max-width: $glp-col-14;
    }

    > .#{$col}-third {
      flex-basis: $glp-col-third;
      max-width: $glp-col-third;
    }

    > .#{$col}-quarter {
      flex-basis: $glp-col-quarter;
      max-width: $glp-col-quarter;
    }

    > .#{$col}-fifth,
    .view-events .view-header li {
      flex-basis: $glp-col-fifth;
      max-width: $glp-col-fifth;
    }

    > .#{$col}-sixth {
      flex-basis: $glp-col-sixth;
      max-width: $glp-col-sixth;
    }

    > .#{$col}-seventh {
      flex-basis: $glp-col-seventh;
      max-width: $glp-col-seventh;
    }

    > .#{$col}-eighth {
      flex-basis: $glp-col-eighth;
      max-width: $glp-col-eighth;
    }

    > .#{$col}-ninth {
      flex-basis: $glp-col-ninth;
      max-width: $glp-col-ninth;
    }

    > .#{$col}-tenth {
      flex-basis: $glp-col-tenth;
      max-width: $glp-col-tenth;
    }

    > .#{$col}-eleventh {
      flex-basis: $glp-col-eleventh;
      max-width: $glp-col-eleventh;
    }

    > .#{$col}-twelth {
      flex-basis: $glp-col-twelth;
      max-width: $glp-col-twelth;
    }

    > .#{$col}-thirteenth {
      flex-basis: $glp-col-thirteenth;
      max-width: $glp-col-thirteenth;
    }

    > .#{$col}-4-of-14 {
      flex-basis: $glp-col-4-of-14;
      max-width: $glp-col-4-of-14;
    }

    > .#{$col}-5-of-14 {
      flex-basis: $glp-col-5-of-14;
      max-width: $glp-col-5-of-14;
    }

    > .#{$col}-6-of-14 {
      flex-basis: $glp-col-6-of-14;
      max-width: $glp-col-6-of-14;
    }

    > .#{$col}-7-of-14 {
      flex-basis: $glp-col-7-of-14;
      max-width: $glp-col-7-of-14;
    }

    > .#{$col}-8-of-14 {
      flex-basis: $glp-col-8-of-14;
      max-width: $glp-col-8-of-14;
    }

    > .#{$col}-9-of-14 {
      flex-basis: $glp-col-9-of-14;
      max-width: $glp-col-9-of-14;
    }

    > .#{$col}-10-of-14 {
      flex-basis: $glp-col-10-of-14;
      max-width: $glp-col-10-of-14;
    }

    > .#{$col}-11-of-14 {
      flex-basis: $glp-col-11-of-14;
      max-width: $glp-col-11-of-14;
    }

    > .#{$col}-12-of-14 {
      flex-basis: $glp-col-12-of-14;
      max-width: $glp-col-12-of-14;
    }

    > .#{$col}-13-of-14 {
      flex-basis: $glp-col-13-of-14;
      max-width: $glp-col-13-of-14;
    }
  }

  .department-working-groups-grid .teaser-working-group  {
    flex-basis: $glp-col-4;
    max-width: $glp-col-4;
  }
}

// Function to generate the offset
@mixin make-off($off) {
  .#{$gl-grid-name} {
    > [data-push-left*='#{$off}-0'] {
      margin-left: 0;
    }

    > [data-push-left*='#{$off}-1'] {
      margin-left: $glp-col-1;
    }

    > [data-push-left*='#{$off}-2'] {
      margin-left: $glp-col-2;
    }

    > [data-push-left*='#{$off}-3'] {
      margin-left: $glp-col-3;
    }

    > [data-push-left*='#{$off}-4'] {
      margin-left: $glp-col-4;
    }

    > [data-push-left*='#{$off}-5'] {
      margin-left: $glp-col-5;
    }

    > [data-push-left*='#{$off}-6'] {
      margin-left: $glp-col-6;
    }

    > [data-push-left*='#{$off}-7'] {
      margin-left: $glp-col-7;
    }

    > [data-push-left*='#{$off}-8'] {
      margin-left: $glp-col-8;
    }

    > [data-push-left*='#{$off}-9'] {
      margin-left: $glp-col-9;
    }

    > [data-push-left*='#{$off}-10'] {
      margin-left: $glp-col-10;
    }

    > [data-push-left*='#{$off}-11'] {
      margin-left: $glp-col-11;
    }

    > [data-push-left*='#{$off}-12'] {
      margin-left: $glp-col-12;
    }

    > [data-push-left*='#{$off}-13'] {
      margin-left: $glp-col-13;
    }

    > [data-push-right*='#{$off}-0'] {
      margin-right: 0;
    }

    > [data-push-right*='#{$off}-1'] {
      margin-right: $glp-col-1;
    }

    > [data-push-right*='#{$off}-2'] {
      margin-right: $glp-col-2;
    }

    > [data-push-right*='#{$off}-3'] {
      margin-right: $glp-col-3;
    }

    > [data-push-right*='#{$off}-4'] {
      margin-right: $glp-col-4;
    }

    > [data-push-right*='#{$off}-5'] {
      margin-right: $glp-col-5;
    }

    > [data-push-right*='#{$off}-6'] {
      margin-right: $glp-col-6;
    }

    > [data-push-right*='#{$off}-7'] {
      margin-right: $glp-col-7;
    }

    > [data-push-right*='#{$off}-8'] {
      margin-right: $glp-col-8;
    }

    > [data-push-right*='#{$off}-9'] {
      margin-right: $glp-col-9;
    }

    > [data-push-right*='#{$off}-10'] {
      margin-right: $glp-col-10;
    }

    > [data-push-right*='#{$off}-11'] {
      margin-right: $glp-col-11;
    }

    > [data-push-right*='#{$off}-12'] {
      margin-right: $glp-col-12;
    }

    > [data-push-right*='#{$off}-13'] {
      margin-right: $glp-col-13;
    }

    > [data-pull-left*='#{$off}-0'] {
      margin-left: -0;
    }

    > [data-pull-left*='#{$off}-1'] {
      margin-left: -$glp-col-1;
    }

    > [data-pull-left*='#{$off}-2'] {
      margin-left: -$glp-col-2;
    }

    > [data-pull-left*='#{$off}-3'] {
      margin-left: -$glp-col-3;
    }

    > [data-pull-left*='#{$off}-4'] {
      margin-left: -$glp-col-4;
    }

    > [data-pull-left*='#{$off}-5'] {
      margin-left: -$glp-col-5;
    }

    > [data-pull-left*='#{$off}-6'] {
      margin-left: -$glp-col-6;
    }

    > [data-pull-left*='#{$off}-7'] {
      margin-left: -$glp-col-7;
    }

    > [data-pull-left*='#{$off}-8'] {
      margin-left: -$glp-col-8;
    }

    > [data-pull-left*='#{$off}-9'] {
      margin-left: -$glp-col-9;
    }

    > [data-pull-left*='#{$off}-10'] {
      margin-left: -$glp-col-10;
    }

    > [data-pull-left*='#{$off}-11'] {
      margin-left: -$glp-col-11;
    }

    > [data-pull-left*='#{$off}-12'] {
      margin-left: -$glp-col-12;
    }

    > [data-pull-left*='#{$off}-13'] {
      margin-left: -$glp-col-13;
    }

    > [data-pull-right*='#{$off}-0'] {
      margin-right: -0;
    }

    > [data-pull-right*='#{$off}-1'] {
      margin-right: -$glp-col-1;
    }

    > [data-pull-right*='#{$off}-2'] {
      margin-right: -$glp-col-2;
    }

    > [data-pull-right*='#{$off}-3'] {
      margin-right: -$glp-col-3;
    }

    > [data-pull-right*='#{$off}-4'] {
      margin-right: -$glp-col-4;
    }

    > [data-pull-right*='#{$off}-5'] {
      margin-right: -$glp-col-5;
    }

    > [data-pull-right*='#{$off}-6'] {
      margin-right: -$glp-col-6;
    }

    > [data-pull-right*='#{$off}-7'] {
      margin-right: -$glp-col-7;
    }

    > [data-pull-right*='#{$off}-8'] {
      margin-right: -$glp-col-8;
    }

    > [data-pull-right*='#{$off}-9'] {
      margin-right: -$glp-col-9;
    }

    > [data-pull-right*='#{$off}-10'] {
      margin-right: -$glp-col-10;
    }

    > [data-pull-right*='#{$off}-11'] {
      margin-right: -$glp-col-11;
    }

    > [data-pull-right*='#{$off}-12'] {
      margin-right: -$glp-col-12;
    }

    > [data-pull-right*='#{$off}-13'] {
      margin-right: -$glp-col-13;
    }
  }
}
